﻿
'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'
'
'  Example taken from http://msdn.microsoft.com/en-us/library/fx6588te.aspx
'
'    Asynchronous Server Socket Example

'  The following example program creates a server that receives connection requests from clients. The 
' server is built with an asynchronous socket, so execution of the server application is not suspended 
' while it waits for a connection from a client. 
'
'+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

Imports System
Imports System.Net
Imports System.Net.Sockets
Imports System.Text
Imports System.Threading
Imports Microsoft.VisualBasic
Imports System.EventArgs



Module modGotABotIF
    Dim strMessageToGotABot As String
    Dim strMessageFromGotABot As String
    Dim evntCommandDone As New ManualResetEvent(False)
    Dim boolTimeOut As Boolean = False


    Public Sub GotABotParseAndRespond()
        '  Parse the received data and respond
        strMessageToGotABot = ftnGotABotTranslate(strMessageFromGotABot)
        evntCommandDone.Set()
        GotATranslatorClass.UpdateForm()
    End Sub


    ' =====================================================================================================================

#Region "GotABot ServBot"




    Public Class GotABot1SocketClass
        Public workSocket As Socket = Nothing ' Client  socket.
        Public Const BufferSize As Integer = 1024 ' Size of receive byteReceiveBuffer.
        Public byteReceiveBuffer(BufferSize) As Byte ' Receive byteReceiveBuffer
        Public sbReceivedData As New StringBuilder ' Received data string.
    End Class 'GotABot1SocketClass





    Public Class GotABot1ServerClass
        ' This server waits for a connection and then uses  asychronous operations to
        ' accept the connection, get data from the connected client, 
        ' perform the GotABot function.
        ' It then disconnects from the client and waits for another client. 

        Public evntGotABotAllDone As New ManualResetEvent(False)
        Public Event evntGotABotCommandReceived(ByVal boolGotABotCommandReceived As Boolean)
        Public Shared Connected As Boolean = False





        Public Sub Main()
            ' Data byteReceiveBuffer for incoming data.
            Dim bytes() As Byte = New [Byte](1023) {}
            ' Establish the local endpoint for the socket.
            Dim ipHostInfo As IPHostEntry = Dns.GetHostEntry(Dns.GetHostName())
            Dim ipAddress As IPAddress = ipAddress.Loopback    ' ipHostInfo.AddressList(UBound(ipHostInfo.AddressList))

            strMessageToGotABot = "Listening"
            Dim localEndPoint As New IPEndPoint(ipAddress, GotABot_Port) ' Create a TCP/IP socket.
            Dim GotABot1Socket As New Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp)
            Dim osInfo As OperatingSystem = System.Environment.OSVersion
            If (Socket.OSSupportsIPv6) Then   ' VISTA = 6.1, Win7 = 6.2
                ipAddress = ipAddress.IPv6Loopback    'ipHostInfo.AddressList(UBound(ipHostInfo.AddressList))
                localEndPoint = New IPEndPoint(ipAddress.IPv6Any, GotABot_Port) ' Create a TCP/IP socket.
                GotABot1Socket = New Socket(AddressFamily.InterNetworkV6, SocketType.Stream, ProtocolType.Tcp)
                GotABot1Socket.SetSocketOption(SocketOptionLevel.IPv6, SocketOptionName.IPv6Only, 0)
            Else
                ipAddress = ipAddress.Loopback    'ipHostInfo.AddressList(UBound(ipHostInfo.AddressList))
                localEndPoint = New IPEndPoint(ipAddress.Any, GotABot_Port) ' Create a TCP/IP socket.
                GotABot1Socket = New Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp)
            End If
            GotABot1Socket.SetSocketOption(SocketOptionLevel.Socket, SocketOptionName.ReuseAddress, 1)
            GotABot1Socket.Bind(localEndPoint)

            While True
                If Not boolShutDown Then
                    Try
                        GotABot1Socket.Listen(100) ' and listen for incoming connections.
                        ' Start an asynchronous socket to listen for connections.
                        While Not boolShutDown
                            ' Wait until a connection is made and processed before continuing.
                            evntGotABotAllDone.Reset() ' Set the event to nonsignaled GotABotSocketClassInstance.
                            evntCommandDone.Reset()
                            If Not boolShutDown Then GotABot1Socket.BeginAccept(New AsyncCallback(AddressOf AcceptCallback), GotABot1Socket)
                            evntGotABotAllDone.WaitOne()
                        End While
                        If boolShutDown Then
                            If GotABot1ServerClass.Connected Then
                                GotABot1ServerClass.Connected = False
                                GotABot1Socket.Disconnect(Not boolShutDown)
                            End If
                            GotABot1Socket.Close()
                        End If
                    Catch ex As Exception
                        If GotABot1Socket.Connected Then
                            GotABot1ServerClass.Connected = False
                            GotABot1Socket.Disconnect(Not boolShutDown)
                        End If
                    End Try
                End If
                GotATranslatorClass.subWait(500)
            End While
        End Sub 'Main

        Public Sub AcceptCallback(ByVal ar As IAsyncResult)
            ' Get the socket that handles the client request.
            Try
                Dim GotABot1Socket As Socket = CType(ar.AsyncState, Socket)
                Dim GotABotSocketInstance As Socket = GotABot1Socket.EndAccept(ar) ' End the operation.

                ' Create the GotABotSocketClassInstance object for the async receive.
                Dim GotABotSocketClassInstance As New GotABot1SocketClass
                GotABotSocketClassInstance.workSocket = GotABotSocketInstance
                GotABotSocketInstance.BeginReceive(GotABotSocketClassInstance.byteReceiveBuffer, 0, GotABot1SocketClass.BufferSize, 0, New AsyncCallback(AddressOf ReadCallback), GotABotSocketClassInstance)
            Catch ex As Exception
            End Try
        End Sub 'AcceptCallback


        Public Sub ReadCallback(ByVal ar As IAsyncResult)
            Dim strContent As String = String.Empty
            Try
                ' Retrieve the GotABotSocketClassInstance object and the GotABot1Socket socket
                ' from the asynchronous GotABotSocketClassInstance object.
                Dim GotABotSocketClassInstance As GotABot1SocketClass = CType(ar.AsyncState, GotABot1SocketClass)
                Dim GotABot1Socket As Socket = GotABotSocketClassInstance.workSocket
                Dim bytesRead As Integer = 0
                bytesRead = GotABot1Socket.EndReceive(ar) ' Read data from the client socket.

                If bytesRead > 0 Then
                    ' There  might be more data, so store the data received so far.
                    GotABotSocketClassInstance.sbReceivedData.Append(Encoding.ASCII.GetString(GotABotSocketClassInstance.byteReceiveBuffer, 0, bytesRead))
                    strContent = GotABotSocketClassInstance.sbReceivedData.ToString() ' Check for CRLF. If it is not there, read more data.
                    If strContent.IndexOf(vbCrLf) > -1 Then
                        ' All the data has been read from the client. 
                        GotABot1ServerClass.Connected = True
                        GotABotToMainIF(strContent)  ' Process the command
                        Send(GotABot1Socket, strMessageToGotABot) ' Send the response.
                        evntCommandDone.WaitOne()
                        evntGotABotAllDone.Set() ' Signal the main thread to continue.

                        evntGotABotAllDone.Reset() ' Set the event to nonsignaled GotABotSocketClassInstance.
                        evntCommandDone.Reset()
                        Dim GotABotSocketClassInstance1 As GotABot1SocketClass = CType(ar.AsyncState, GotABot1SocketClass)
                        GotABotSocketClassInstance.sbReceivedData = New StringBuilder("")
                        GotABotSocketClassInstance = Nothing
                        GotABot1Socket.BeginReceive(GotABotSocketClassInstance1.byteReceiveBuffer, 0, GotABot1SocketClass.BufferSize, 0, New AsyncCallback(AddressOf ReadCallback), GotABotSocketClassInstance1)
                    Else
                        ' Not all data received. Get more.
                        GotABot1Socket.BeginReceive(GotABotSocketClassInstance.byteReceiveBuffer, 0, GotABot1SocketClass.BufferSize, 0, New AsyncCallback(AddressOf ReadCallback), GotABotSocketClassInstance)
                    End If
                End If
            Catch ex As Exception
                GotABot1ServerClass.Connected = False
            End Try
        End Sub 'ReadCallback

        Private Sub Send(ByVal GotABot1Socket As Socket, ByVal strMessage As String)
            ' Convert the string strMessage to byte strMessage using ASCII encoding.
            Dim bytestrMessage As Byte() = Encoding.ASCII.GetBytes(strMessage)

            ' Begin sending strMessage to the remote device.
            Try
                GotABot1Socket.BeginSend(bytestrMessage, 0, bytestrMessage.Length, 0, New AsyncCallback(AddressOf SendCallback), GotABot1Socket)
            Catch ex As Exception
            End Try
        End Sub 'Send


        Private Sub SendCallback(ByVal ar As IAsyncResult)
            ' Retrieve the socket from the GotABotSocketClassInstance object.
            Try
                Dim GotABot1Socket As Socket = CType(ar.AsyncState, Socket)
            Catch ex As Exception
            End Try
        End Sub 'SendCallback




        Private Sub GotABotToMainIF(ByVal strMessage As String)
            If boolTimeOut Then
                strMessageFromGotABot = "GotABot_Timeout" & vbCr
                boolTimeOut = False
            Else
                strMessageFromGotABot = strMessage
            End If
            RaiseEvent evntGotABotCommandReceived(True)
        End Sub
    End Class 'GotABot1ServerClass

#End Region




End Module
